Web/FishMap.Web/Controllers/FishSpeciesController.cs
namespace FishMap.Web.Controllers
{
    using FishMap.Services.Data.Contracts;
    using FishMap.Web.ViewModels.FishSpecies;
    using Microsoft.AspNetCore.Mvc;

    public class FishSpeciesController : Controller
    {
        private readonly IFishSpeciesService fishSpeciesService;

        public FishSpeciesController(IFishSpeciesService fishSpeciesService)
        {
            this.fishSpeciesService = fishSpeciesService;
        }

        public IActionResult All(int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;

            var viewModel = new FishSpeciesListViewModel
            {
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.fishSpeciesService.GetAllCount(),
                FishSpecies = this.fishSpeciesService.GetAllForPaging(id, itemsPerPage),
            };

            return this.View(viewModel);
        }

        public IActionResult ById(int id)
        {
            var viewModel = this.fishSpeciesService.GetById(id);

            if (viewModel == null)
            {
                return this.NotFound();
            }

            return this.View(viewModel);
        }
    }
}

Web/FishMap.Web/Controllers/GroupTripsController.cs
namespace FishMap.Web.Controllers
{
    using System;
    using System.Threading.Tasks;

    using FishMap.Common;
    using FishMap.Data.Models;
    using FishMap.Services.Data.Contracts;
    using FishMap.Web.ViewModels.GroupTrips;
    using Microsoft.AspNetCore.Authorization;
    using Microsoft.AspNetCore.Identity;
    using Microsoft.AspNetCore.Mvc;

    [Authorize]
    public class GroupTripsController : BaseController
    {
        private readonly UserManager<ApplicationUser> userManager;
        private readonly IGroupTripsService groupTripsService;
        private readonly IFishSpeciesService fishService;

        public GroupTripsController(
            UserManager<ApplicationUser> userManager,
            IGroupTripsService groupTripsService,
            IFishSpeciesService fishService)
        {
            this.userManager = userManager;
            this.groupTripsService = groupTripsService;
            this.fishService = fishService;
        }

        [HttpGet]
        public IActionResult Create()
        {
            var viewModel = new GroupTripCreateInputModel();
            viewModel.FishSpeciesItems = this.fishService.GetAllForSelectList();
            return this.View(viewModel);
        }

        [HttpPost]
        public async Task<IActionResult> Create(GroupTripCreateInputModel inputModel)
        {
            if (!this.ModelState.IsValid)
            {
                var viewModel = new GroupTripCreateInputModel();
                viewModel.FishSpeciesItems = this.fishService.GetAllForSelectList();
                return this.View(viewModel);
            }

            var user = await this.userManager.GetUserAsync(this.User);
            var id = await this.groupTripsService.CreateAsync(inputModel, user.Id);

            return this.RedirectToAction(nameof(this.ById), new { id });
        }

        public IActionResult Upcoming(int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;
            var viewModel = new GroupTripsListViewModel
            {
                GroupTrips = this.groupTripsService.GetUpcomingForPaging(id, itemsPerPage),
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.groupTripsService.GetUpcomingCount(),
            };

            return this.View(viewModel);
        }

        public async Task<IActionResult> ById(EnrollRouteData routeData)
        {
            this.ViewBag.Error = routeData.ErrorMessage;
            var user = await this.userManager.GetUserAsync(this.User);

            var viewModel = this.groupTripsService.GetById(routeData.Id);

            if (viewModel == null)
            {
                return this.NotFound();
            }

            viewModel.IsUserAdmin = await this.userManager.IsInRoleAsync(user, GlobalConstants.AdministratorRoleName);
            viewModel.IsUserCreator = this.groupTripsService.IsUserCreator(user.Id, routeData.Id);

            return this.View(viewModel);
        }

        public async Task<IActionResult> Enroll(int id)
        {
            var user = await this.userManager.GetUserAsync(this.User);

            try
            {
                await this.groupTripsService.EnrollUser(id, user.Id);
            }
            catch (Exception e)
            {
                if (e.Message == GlobalConstants.NotFoundExceptionMessage)
                {
                    return this.NotFound();
                }

                var errorMessage = e.Message;
                return this.RedirectToAction(nameof(this.ById), new EnrollRouteData { Id = id, ErrorMessage = errorMessage });
            }

            return this.RedirectToAction(nameof(this.ById), new EnrollRouteData { Id = id });
        }

        public async Task<IActionResult> Delete(int id)
        {
            var user = await this.userManager.GetUserAsync(this.User);

            if (!this.User.IsInRole(GlobalConstants.AdministratorRoleName)
                && !this.groupTripsService.IsUserCreator(user.Id, id))
            {
                return this.Unauthorized();
            }

            try
            {
                await this.groupTripsService.Delete(id);
            }
            catch (NullReferenceException)
            {
                return this.NotFound();
            }

            return this.RedirectToAction(nameof(this.Upcoming));
        }

        public IActionResult OrderBy(string order, int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;

            var viewModel = new GroupTripsListViewModel
            {
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.groupTripsService.GetUpcomingCount(),
            };

            switch (order)
            {
                case "CreatedOnDesc":
                    viewModel.GroupTrips = this.groupTripsService.OrderUpcomingByCreatedOnDesc(id, itemsPerPage);
                    break;
                case "CreatedOnAsc":
                    viewModel.GroupTrips = this.groupTripsService.OrderUpcomingByCreatedOnAsc(id, itemsPerPage);
                    break;
                case "TripDateDesc":
                    viewModel.GroupTrips = this.groupTripsService.OrderUpcomingByTripDateDesc(id, itemsPerPage);
                    break;
                case "TripDateAsc":
                    viewModel.GroupTrips = this.groupTripsService.OrderUpcomingByTripDateAsc(id, itemsPerPage);
                    break;
                default:
                    return this.NotFound();
            }

            return this.View(viewModel);
        }
    }
}

Web/FishMap.Web/Controllers/SettingsController.cs
namespace FishMap.Web.Controllers
{
    using System;
    using System.Threading.Tasks;

    using FishMap.Data.Common.Repositories;
    using FishMap.Data.Models;
    using FishMap.Services.Data;
    using FishMap.Web.ViewModels.Settings;

    using Microsoft.AspNetCore.Mvc;

    public class SettingsController : BaseController
    {
        private readonly ISettingsService settingsService;

        private readonly IDeletableEntityRepository<Setting> repository;

        public SettingsController(ISettingsService settingsService, IDeletableEntityRepository<Setting> repository)
        {
            this.settingsService = settingsService;
            this.repository = repository;
        }

        public IActionResult Index()
        {
            var settings = this.settingsService.GetAll<SettingViewModel>();
            var model = new SettingsListViewModel { Settings = settings };
            return this.View(model);
        }

        public async Task<IActionResult> InsertSetting()
        {
            var random = new Random();
            var setting = new Setting { Name = $"Name_{random.Next()}", Value = $"Value_{random.Next()}" };

            await this.repository.AddAsync(setting);
            await this.repository.SaveChangesAsync();

            return this.RedirectToAction(nameof(this.Index));
        }
    }
}

Web/FishMap.Web/Controllers/TripsController.cs
namespace FishMap.Web.Controllers
{
    using System.Threading.Tasks;

    using FishMap.Common;
    using FishMap.Data.Models;
    using FishMap.Services.Data.Contracts;
    using FishMap.Web.ViewModels.Trips;
    using Microsoft.AspNetCore.Authorization;
    using Microsoft.AspNetCore.Identity;
    using Microsoft.AspNetCore.Mvc;

    [Authorize]
    public class TripsController : BaseController
    {
        private readonly ITripsService tripService;
        private readonly UserManager<ApplicationUser> userManager;

        public TripsController(
            ITripsService tripService,
            UserManager<ApplicationUser> userManager)
        {
            this.tripService = tripService;
            this.userManager = userManager;
        }

        public IActionResult Create()
        {
            return this.View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(CreateTripInputModel input)
        {
            if (!this.ModelState.IsValid)
            {
                return this.View();
            }

            var user = await this.userManager.GetUserAsync(this.User);
            var tripToFishData = await this.tripService.CreateAsync(input, user.Id);

            return this.RedirectToAction(nameof(FishController.Create), nameof(FishController).Replace("Controller", string.Empty), tripToFishData);
        }

        public IActionResult All(int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;

            var viewModel = new TripListViewModel
            {
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.tripService.GetAllCount(),
                Trips = this.tripService.GetAllForPaging(id, itemsPerPage),
            };

            return this.View(viewModel);
        }

        public async Task<IActionResult> ById(int id)
        {
            var viewModel = this.tripService.GetById(id);

            if (viewModel == null)
            {
                return this.NotFound();
            }

            var user = await this.userManager.GetUserAsync(this.User);
            viewModel.IsUserAdmin = await this.userManager.IsInRoleAsync(user, GlobalConstants.AdministratorRoleName);
            viewModel.IsUserCreator = this.tripService.IsUserCreator(user.Id, id);

            return this.View(viewModel);
        }

        public IActionResult OrderBy(string order, int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;

            var viewModel = new TripListViewModel
            {
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.tripService.GetAllCount(),
            };

            switch (order)
            {
                case "CreatedOnDesc":
                    viewModel.Trips = this.tripService.OrderAllByCreatedOnDesc(id, itemsPerPage);
                    break;
                case "CreatedOnAsc":
                    viewModel.Trips = this.tripService.OrderAllByCreatedOnAsc(id, itemsPerPage);
                    break;
                case "TripDateDesc":
                    viewModel.Trips = this.tripService.OrderAllByTripDateDesc(id, itemsPerPage);
                    break;
                case "TripDateAsc":
                    viewModel.Trips = this.tripService.OrderAllByTripDateAsc(id, itemsPerPage);
                    break;
                default:
                    return this.NotFound();
            }

            return this.View(viewModel);
        }

        public async Task<IActionResult> Delete(int id)
        {
            var user = await this.userManager.GetUserAsync(this.User);

            if (!this.User.IsInRole(GlobalConstants.AdministratorRoleName)
                && !this.tripService.IsUserCreator(user.Id, id))
            {
                return this.Unauthorized();
            }

            try
            {
                await this.tripService.Delete(id);
            }
            catch (System.NullReferenceException)
            {
                return this.NotFound();
            }

            return this.RedirectToAction(nameof(this.All));
        }
    }
}

Web/FishMap.Web/Views/Shared/_Layout.cshtml
@using FishMap.Common
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@this.ViewData["Title"] - @GlobalConstants.SystemName</title>
    <link href="~/lib/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet" asp-append-version="true" />
    <link href="~/css/site.min.css" rel="stylesheet" asp-append-version="true" />
    <link href="~/css/bootstrap.min.css" rel="stylesheet" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="border-bottom navbar navbar-expand-lg navbar-dark bg-primary">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index"><i class="fas fa-fish fa-lg mr-2"></i>@GlobalConstants.SystemName</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        @if (this.User.Identity.IsAuthenticated)
                        {
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    Излети
                                </a>
                                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" asp-controller="Trips" asp-action="All">Всички</a>
                                    <a class="dropdown-item" asp-controller="Trips" asp-action="Create">Добави</a>
                                </div>
                            </li>
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    Групови излети
                                </a>
                                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" asp-controller="GroupTrips" asp-action="Upcoming">Предстоящи</a>
                                    <a class="dropdown-item" asp-controller="GroupTrips" asp-action="Create">Добави</a>
                                </div>
                            </li>
                        }
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="FishSpecies" asp-action="All">Рибите в България</a>
                        </li>
                        @*<li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Settings" asp-action="Index">Settings</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>*@
                    </ul>
                </div>
            </div>
        </nav>
    </header>

    <div class="container">
        <partial name="_CookieConsentPartial" />
        <main role="main" class="pb-3">
            @this.RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted bg-dark">
        <div class="container">
            &copy; @DateTime.Now.Year - @GlobalConstants.SystemName - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>

    <script src="~/lib/jquery/dist/jquery.min.js" asp-append-version="true"></script>
    <script src="~/lib/jquery-validation/dist/jquery.validate.min.js" asp-append-version="true"></script>
    <script src="~/lib/jquery-validation-unobtrusive/dist/jquery.validate.unobtrusive.js" asp-append-version="true"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js" integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4" crossorigin="anonymous"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.min.js" asp-append-version="true"></script>
    <script src="~/js/site.min.js" asp-append-version="true"></script>
    <script src="https://kit.fontawesome.com/8a370e4c1b.js" crossorigin="anonymous"></script>
    @await this.RenderSectionAsync("Scripts", required: false)
</body>
</html>

Web/FishMap.Web/Views/Shared/_OrderByDropdownPartial.cshtml
@{
    ViewData["Title"] = "_SearchDropdownPartial";
}

    <div class="row mb-3 d-flex flex-row-reverse">
        <div class="dropdown">
            <button class="btn btn-primary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                Сортиране по
            </button>
            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                <a class="dropdown-item" asp-action="OrderBy" asp-route-order="TripDateDesc">Дата на излет (най-нови)</a>
                <a class="dropdown-item" asp-action="OrderBy" asp-route-order="TripDateAsc">Дата на излет (най-стари)</a>
                <div class="dropdown-divider"></div>
                <a class="dropdown-item" asp-action="OrderBy" asp-route-order="CreatedOnDesc">Дата на добавяне (най-нови)</a>
                <a class="dropdown-item" asp-action="OrderBy" asp-route-order="CreatedOnAsc">Дата на добавяне (най-стари)</a>
            </div>
        </div>
    </div>

Web/FishMap.Web/Views/Shared/_PagingPartial.cshtml
@model PagingViewModel
    <nav aria-label="..." class="mb-5">
        <ul class="pagination justify-content-center">
            <li class="page-item @if (!Model.HasPreviousPage) { <text>disabled</text>} ">
                <a class="page-link" asp-action="@ViewContext.RouteData.Values["action"].ToString()" asp-route-order="@Context.Request.Query["order"]" asp-route-id="@Model.PreviousPageNumber">Previous</a>
            </li>
            @for (int i = Model.PageNumber - 4; i < Model.PageNumber; i++)
            {
                if (i > 0)
                {
                    <li class="page-item"><a class="page-link" asp-action="@ViewContext.RouteData.Values["action"].ToString()" asp-route-order="@Context.Request.Query["order"]" asp-route-id="@i">@i</a></li>
                }
            }
            <li class="page-item active" aria-current="page">
                <span class="page-link">
                    @Model.PageNumber
                    <span class="sr-only">(current)</span>
                </span>
            </li>
            @for (int i = Model.PageNumber + 1; i <= Model.PageNumber + 4; i++)
            {
                if (i <= Model.PagesCount)
                {
                    <li class="page-item"><a class="page-link" asp-action="@ViewContext.RouteData.Values["action"].ToString()" asp-route-order="@Context.Request.Query["order"]" asp-route-id="@i">@i</a></li>
                }
            }
            <li class="page-item @if (!Model.HasNextPage) { <text>disabled</text> }">
                <a class="page-link" asp-action="@ViewContext.RouteData.Values["action"].ToString()" asp-route-order="@Context.Request.Query["order"]" asp-route-id="@Model.NextPageNumber">Next</a>
            </li>
        </ul>
    </nav>